Index: ip_fw_pfil.c
===================================================================
RCS file: /home/ncvs/src/sys/netinet/ip_fw_pfil.c,v
retrieving revision 1.7
diff -u -p -r1.7 ip_fw_pfil.c
--- ip_fw_pfil.c	27 Aug 2004 15:16:22 -0000	1.7
+++ ip_fw_pfil.c	9 Sep 2004 12:21:03 -0000
@@ -100,6 +100,7 @@ ipfw_check_in(void *arg, struct mbuf **m
 		m_tag_delete(*m0, dn_tag);
 	}
 
+again:
 	args.m = *m0;
 	ipfw = ipfw_chk(&args);
 	*m0 = args.m;
@@ -127,7 +128,7 @@ ipfw_check_in(void *arg, struct mbuf **m
 			*m0 = NULL;
 			return 0;	/* packet consumed */
 		} else
-			goto pass;	/* continue with packet */
+			goto again;	/* continue with packet */
 	}
 
 #ifdef IPFIREWALL_FORWARD
@@ -182,6 +183,7 @@ ipfw_check_out(void *arg, struct mbuf **
 		m_tag_delete(*m0, dn_tag);
 	}
 
+again:
 	args.m = *m0;
 	args.oif = ifp;
 	ipfw = ipfw_chk(&args);
@@ -209,7 +211,7 @@ ipfw_check_out(void *arg, struct mbuf **
 			*m0 = NULL;
 			return 0;	/* packet consumed */
 		} else
-			goto pass;	/* continue with packet */
+			goto again;	/* continue with packet */
         }
 
 #ifdef IPFIREWALL_FORWARD
@@ -307,12 +309,8 @@ ipfw_divert(struct mbuf **m, int incomin
 		divert_packet(clone, incoming);
 
 teeout:
-	if (tee) {
-		mtag = m_tag_find(*m, PACKET_TAG_DIVERT, NULL);
-		if (mtag != NULL)
-			m_tag_delete(*m, mtag);
-		return 0;	/* continue with original packet. */
-	}
+	if (tee)
+		return 0;	/* Continue with original packet. */
 
 	/* Packet diverted and consumed */
 	return 1;
